<?php

require __DIR__ . "/../vendor/autoload.php";
require __DIR__ . "/../vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/../vendor/teknisa/libraries-next/scripts/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$routes = array();
$routes[] = __DIR__ . '/../vendor/teknisa/libraries-next/libRoutes.json';
$routes[] = __DIR__ . '/../src/LoginMobile/config/routes.json';
$routes[] = __DIR__ . '/../config/routes.json';

$instanceManager->loadFromFile('../config/db.xml');
$instanceManager->loadFromFile('../config/general.xml');
$instanceManager->loadFromFile('../config/report.xml');
$instanceManager->loadFromFile('../config/environment.xml');
$instanceManager->loadFromFile('../src/LoginMobile/config/controllers.xml');
$instanceManager->loadFromFile('../config/parameters.xml');
$instanceManager->loadFromFile('../config/erp.xml');

$container = $instanceManager->getContainer();

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));

$instanceManager->compile();