/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRUPCLIE                                                 */
/* Tabela : GRUPCLIE                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 14/05/2004 - WELBERT GONALVES MOITINHA                                    */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_GRUPCLIE
BEFORE INSERT OR UPDATE OR DELETE
ON GRUPCLIE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUGRCL := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (:OLD.CDGRUPCLIE <> :NEW.CDGRUPCLIE ) OR
         (:OLD.NMGRUPCLIE <> :NEW.NMGRUPCLIE) THEN          
         :NEW.DTULTATUGRCL := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('GRUPCLIE', '', 'CDGRUPCLIE='||:OLD.CDGRUPCLIE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE GRUPCLIE MODIFY DTULTATUGRCL DEFAULT SYSDATE
/