/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SIMULAPAD                                                */
/* Tabela : SIMULAPAD                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 17/05/2004 - RENATA DINIZ                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SIMULAPAD
BEFORE INSERT OR UPDATE OR DELETE
ON SIMULAPAD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSIMP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDSIMULAPAD ,0)  <> NVL(:NEW.CDSIMULAPAD ,0)) OR
         (NVL(:OLD.NMSIMULAPAD  ,0) <> NVL(:NEW.NMSIMULAPAD  ,0)) THEN
         :NEW.DTULTATUSIMP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SIMULAPAD', '', 'CDSIMULAPAD='||:OLD.CDSIMULAPAD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SIMULAPAD MODIFY DTULTATUSIMP DEFAULT SYSDATE
/

