/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PROP                                                     */
/* Tabela : PRODPREFMED                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PROP'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PROP
GO

CREATE TRIGGER DTULTATU_PROP
ON PRODPREFMED
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODPREFMED', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';'+
                                            'CDPRODUTO='+ CDPRODUTO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODPREFMED
      SET DTULTATUPROP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PRODPREFMED.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))     AND
            (ISNULL(PRODPREFMED.QTMEDSOLPROD,0) = ISNULL(INSERTED.QTMEDSOLPROD,0));
   END;
END;
GO

